from locust import HttpUser, TaskSet, task, between
#from requests_toolbelt.adapters.source import SourceAddressAdapter
from ssladapter_nick import SourceAddressAdapter
#from requests_toolbelt import SSLAdapter
import random
import requests
import urllib3
urllib3.disable_warnings()
import socket

def get_ip():
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    try:
        # doesn't even have to be reachable
        s.connect(('10.255.255.255', 1))
        IP = s.getsockname()[0]
    except:
        IP = '127.0.0.1'
    finally:
        s.close()
    return IP

# def login(self):
#     #ua = pick_ua()
#     self.client.get("/login.php", auth=("admin", "password"))

def pick_ua():
    ua1 = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36"
    ua2 = "Mozilla/5.0 (iPhone; CPU iPhone OS 5_1_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3"
    ua3 = "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0"
    ua4 = "Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko"
    ua5 = "Mozilla/5.0(iPad; U; CPU OS 4_3 like Mac OS X; en-us) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/5.0.2 Mobile/8F191 Safari/6533.18.5"
    ua = [ua1, ua2, ua3, ua4, ua5]
    return(random.choice(ua))


def pick_cipher():
    cipher1 = ":AES128-GCM-SHA256" #iana TLS_RSA_WITH_AES_128_GCM_SHA256
    cipher2 = ":ECDHE-ECDSA-AES256-SHA" #iana TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA384
    cipher3 = ":ECDHE-ECDSA-AES128-GCM-SHA256"  #iana TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256
    cipher4 = ":AES128-SHA256" #iana TLS_RSA_WITH_AES_128_CBC_SHA256


    cipherlist = [cipher1, cipher2, cipher3, cipher4]
    return(random.choice(cipherlist))

    # url1 = "http://"+vip+"/imgs/logo.png"
    # url2 = "https://"+vip+"/"
    # url3 = "http://"+vip+"/imgs/conversion.js"
    # url4 = "https://"+vip+"/imgs/header.png"
    # url5 = "https://"+vip+"/assets/avi.webm"
    # url6 = "https://"+vip+"/128kb.txt"
    # url7 = "https://"+vip+"/imgs/logo.png"
def pick_tls():
    tls1 = "ssl.PROTOCOL_TLSv1_1"
    tls2 = "ssl.PROTOCOL_TLSv1"
    tls3 = "ssl.PROTOCOL_TLSv1_2"
    tlslist = [tls1, tls2, tls3]
    return(random.choice(tlslist))

class UserBehavior(TaskSet):
    def __init__(self, parent):
        super().__init__(parent)
        #print(self.locust.host)

    @task(100)
    def index(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/", headers={'user-agent': ua}, verify=False)

    @task(100)
    def httplogo(self):
        ua = pick_ua()
        self.client.get("http://" + self.user.host + "/imgs/logo.png", headers={'user-agent': ua}, verify=False)

    @task(50)
    def conversion(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/imgs/conversion.js", headers={'user-agent': ua}, verify=False)

    @task(100)
    def header(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/imgs/header.png", headers={'user-agent': ua}, verify=False)

    # @task(1)
    # def avi_webm(self):
    #     ua = pick_ua()      
    #     self.client.get("https://" + self.locust.host + "/assets/avi.webm", headers={'user-agent': ua}, verify=False)

    @task(100)
    def textfile(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/128kb.txt", headers={'user-agent': ua}, verify=False)

    @task(100)
    def httpslogo(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/imgs/logo.png", headers={'user-agent': ua}, verify=False)

    @task(100)
    def attack(self):
        ua = pick_ua()
        self.client.get("https://" + self.user.host + "/", params={'name': '<script>alert(‘Im attacking your JAM!’)</script>'}, headers={'user-agent': ua}, verify=False)

    def on_start(self):
        # List of IP's that can be used as "source" - hardcoded for simplicity
        # ips = ["161.98.255.1", "37.60.63.2", "206.223.191.1", "23.26.110.2", "27.113.239.2", "42.97.255.1", "132.247.255.2", "14.192.95.1", "37.16.63.1", "49.213.31.2", "41.67.128.1", "27.97.1.2"]
        # ip = random.choice(ips)
        ip = get_ip()
        #self.client.sess
        #self.client.verify = False
        #cipher = pick_cipher()
        #tlschoice = pick_tls()
        #requests.packages.urllib3.util.ssl_.DEFAULT_CIPHERS += cipher
        self.client.mount("https://", SourceAddressAdapter(ip))
        self.client.mount("http://", SourceAddressAdapter(ip))
        self.client.verify = False
        #login(self)

    # def on_stop(self):
    #     logout(self)

class WebsiteUser(HttpUser):
    tasks = [UserBehavior]
    wait_time = between(1, 4)
